package ru.dbotthepony.kstarbound.lua

import ru.dbotthepony.kstarbound.Starbound

class LuaUpdateComponent(val lua: LuaEnvironment) {
	var stepCount = 1
	private var steps = 0

	init {
		val script = lua.newTable()
		lua.globals["script"] = script

		script["updateDt"] = luaFunction {
			returnBuffer.setTo(stepCount * Starbound.TIMESTEP)
		}

		script["setUpdateDelta"] = luaFunction { ticks: Int ->
			stepCount = ticks
		}
	}

	fun update() {
		if (steps++ >= stepCount) {
			steps = 0
			lua.invokeGlobal("update")
		}
	}
}
